/*
Az ISP-probapanelen levo mikrovezerlo es a PC kozotti soros (RS-232) kommunikaciot
megvalosito program.

A program leellenorzesehez szukseg van egy Terminal programra, pl. a BrayTerminal-ra.

A mikrovezerlo ujrainditas utan egy udvozlo szoveget kuld a PC fele, majd a PC-rol
kuldott karakterlancot a mikrovezerlo fogadja es azt visszakuldi a PC-nek.
*/

//PC_Comm.c
//A program max 64 karakterbol allo csomagokat fogad es ezeket
//visszakuldi a Terminal programnak

#include <avr/io.h>
#include <stdlib.h>
#include "uart.h"


int main(void) {
  char string[64], UBRR_reg[4];
  unsigned char count = 0;

  //Az inicializalo program futtatasa
  USARTinit();
  
  sei();
  
  //Udvozles
  sendString("A PC_Comm.c kesz kommunikalni.\r");

  //A program bemutatkozasa
  sendString("Jelenleg a PC_Comm demoval kommunikal.\r");

  itoa(UBRR0L, UBRR_reg, 10);
  sendString("Baudrate regiszter tartalma: ");
  sendString(UBRR_reg);
  sendChar('\r');
  
  //A vegtelen, szamitogeppel valo, beszelgetes elkezdese
  for (;;) {
    //Ellenorzes, varakozik-e egy karakter
    if (isCharAvailable() == 1) {
      //Ha megerkezett egy karakter, megfogjuk azt
      
	  string[count++] = receiveChar();
	  
     //Maximum 64 byte-os csomag fogadasa
      if (string[count - 1] == '\r') { //A Hyperterminal string befejezese \r karakterekkel
        string[count - 1] = '\0'; //Stringge konvertalas

		sendString(string);
        sendChar('\r');
        string[0] = '\0';
        count = 0;

      }
	  else
	    if (count > 64) {
          count = 0;
          string[0] = '\0';
		  sendChar('\r');
          sendString("Hiba - > mint 64 karakter erkezett.\r");
        }
	}
  }

  return(0);
}
